package net.greenfieldtech.cloudonixsdk.cloudonixdialer.fragments;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import butterknife.Bind;
import butterknife.OnClick;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.R;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.activities.SettingsActivity;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.utils.SdkFacade;
import net.greenfieldtech.cloudonixsdk.utils.StorageAndPrefsWrapper;

/**
 * Created by alex on 20.04.16.
 */

public class StatusFragment extends BaseFragment {

  public static final int REQUEST_EDIT_PREFS = 1001;

  @Bind(R.id.root)
  RelativeLayout root;
  @Bind(R.id.tv_server)
  TextView tvServer;
  @Bind(R.id.tv_port)
  TextView tvPort;
  @Bind(R.id.tv_protocol)
  TextView tvProtocol;
  @Bind(R.id.tv_username)
  TextView tvUsername;
  @Bind(R.id.tv_password)
  TextView tvPassword;
  @Bind(R.id.tv_display_name)
  TextView tvDisplayName;
  @Bind(R.id.tv_registration)
  TextView tvRegistration;
  @Bind(R.id.tv_ice)
  TextView tvIce;
  @Bind(R.id.tv_dns_srv)
  TextView tvDns;
  @Bind(R.id.tv_codec)
  TextView tvCodec;
  @Bind(R.id.tv_user_agent)
  TextView tvUseragent;
  @Bind(R.id.tv_maximal_rate)
  TextView tvMaxRate;
  @Bind(R.id.tv_minimal_rate)
  TextView tvMinRate;

  @Bind(R.id.iv_registration)
  ImageView ivRegistration;
  @Bind(R.id.iv_ice)
  ImageView ivIce;
  @Bind(R.id.iv_dns_srv)
  ImageView iv_Dns;

  @Override
  public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
    super.onViewCreated(view, savedInstanceState);
    setInfo();
  }

  @Override
  public int getLayoutResource() {
    return R.layout.fragment_status;
  }

  @OnClick(R.id.btn_edit)
  void edit() {
    startActivityForResult(new Intent(getActivity(), SettingsActivity.class), REQUEST_EDIT_PREFS);
  }

  @Override
  public void onActivityResult(int requestCode, int resultCode, Intent data) {
    super.onActivityResult(requestCode, resultCode, data);
    if (requestCode == REQUEST_EDIT_PREFS) {
      setInfo();
    }
  }

  private void setInfo() {
    StorageAndPrefsWrapper prefs = StorageAndPrefsWrapper.getInstance();

    tvServer.setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_SERVER, ""));
    tvPort.setText(
        prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_TRANSPORT_PORT, ""));
    tvProtocol
        .setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_TRANSPORT, ""));
    tvUsername
        .setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_USERNAME, ""));
    tvPassword
        .setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_PASSWORD, ""));
    tvDisplayName
        .setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_DISPLAYNAME, ""));
    tvRegistration.setText(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_REGISTRATION, false) ? "YES"
            : "NO");
    ivRegistration.setImageResource(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_REGISTRATION, false)
            ? R.drawable.ic_settings_check : R.drawable.ic_settings_cross);
    tvIce.setText(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.ENABLE_ICE, false) ? "YES" : "NO");
    ivIce.setImageResource(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.ENABLE_ICE, false)
            ? R.drawable.ic_settings_check : R.drawable.ic_settings_cross);
    tvDns.setText(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_USE_DNS_SRV, false) ? "YES"
            : "NO");
    iv_Dns.setImageResource(
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.ACCOUNT_USE_DNS_SRV, false)
            ? R.drawable.ic_settings_check : R.drawable.ic_settings_cross);
    tvCodec.setText(SdkFacade.getEnabledCodecs());
    tvUseragent.setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.USER_AGENT, ""));
    tvMinRate.setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.MIN_RATE, ""));
    tvMaxRate.setText(prefs.getString(StorageAndPrefsWrapper.PreferencesKeys.MAX_RATE, ""));
  }

}
